<?php
/**
 * Plugin Name: GeoSmart
 * Plugin URI: http://www.samuelfolkes.com/projects/geosmart
 * Description: GeoSmart automatically adds city-precise location information for comment authors to comment metadata. GeoSmart can also display a Google map showing comment author distribution across the globe. Requires PHP 5. Map display requires a <a href="http://code.google.com/apis/maps/signup.html" title="Google Maps API Key" target="_blank">Google Maps API Key</a>.
 * Version: 1.0.0
 * Author: Samuel Folkes
 * Author URI: http://www.samuelfolkes.com/
 * Copyright: 2009 Samuel Folkes
 */
 
/*  Copyright 2009 Samuel A. Folkes  (email : projects@samuelfolkes.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

global $wpdb;
define('GS_VERSION', '1.0.0');
define('GS_TABLE', $wpdb->prefix . 'geosmart');
define('GS_PATH', WP_PLUGIN_URL . '/geosmart/');

class geoSmart
{
/**
 * Class constructor. Not used in current version.
 */
 function __construct() {}

/**
 * Displays GeoSmart options page in admin panel.
 */
 public function displayAdmin()
 {
	$adminOptions = get_option('geosmart-options');
	if(isset($_POST['GeoSmartGetComments']))
	{
		$this->getCommentorLocations()
		?>
		<div class="updated"><p><strong><?php _e('GeoSmart Database Successfully Updated.','GeoSmart'); ?></strong></p></div>
		<?php
	}
	if(isset($_POST['GeoSmartUpdate']))
	{
		if(isset($_POST['GeoSmartLocation'])) $adminOptions['commenters'] = $_POST['GeoSmartLocation'];
		if(isset($_POST['GeoSmartMap'])) $adminOptions['map'] = $_POST['GeoSmartMap'];
		if(isset($_POST['GeoSmartLink'])) $adminOptions['show_link'] = $_POST['GeoSmartLink'];
		if(isset($_POST['GeoSmartKey']) && !empty($_POST['GeoSmartKey']))
		{
		?>
<script type="text/javascript">
	var KillAlerts = true;
	var realAlert = alert;
	var alert = new Function('a', 'if(!KillAlerts){realAlert(a)}');
</script>

<script src="http://maps.google.com/maps?file=api&v=2&sensor=false&key=<?php echo $_POST['GeoSmartKey']; ?>" type="text/javascript"></script>

<script type="text/javascript">
    KillAlerts = false;

    if (GBrowserIsCompatible()) 
	{
      var ValidKey = true;
    } 
	else 
	{
      if (G_INCOMPAT) 
	  {
        alert("Your Google Maps API Key is Invalid!");
      } 
    } 
</script>
		
		<?php
		$adminOptions['api-key'] = $_POST['GeoSmartKey'];
		}
		if(!isset($_POST['GeoSmartKey']))
		{
		?>
		<script type="text/javascript">
			var ValidKey = true;
		</script>
		<?php
		}
		if(isset($_POST['GeoSmartAuto'])) $adminOptions['auto_position'] = $_POST['GeoSmartAuto'];
		if(isset($_POST['GeoSmartWidth']) && !empty($_POST['GeoSmartWidth'])) 
		{
			if(is_numeric($_POST['GeoSmartWidth']))
			{
				$adminOptions['map_width'] = $_POST['GeoSmartWidth'];
			}
		}
		if(isset($_POST['GeoSmartHeight']) && !empty($_POST['GeoSmartHeight'])) 
		{
			if(is_numeric($_POST['GeoSmartHeight']))
			{
				$adminOptions['map_height'] = $_POST['GeoSmartHeight'];
			}
		}
		if(isset($_POST['GeoSmartLatitude']) && !empty($_POST['GeoSmartLatitude'])) 
		{
			if(is_numeric($_POST['GeoSmartLatitude']))
			{
				$adminOptions['map_lat'] = $_POST['GeoSmartLatitude'];
			}
		}
		if(isset($_POST['GeoSmartLongitude']) && !empty($_POST['GeoSmartLongitude'])) 
		{
			if(is_numeric($_POST['GeoSmartLongitude']))
			{
				$adminOptions['map_long'] = $_POST['GeoSmartLongitude'];
			}
		}
		if(isset($_POST['GeoSmartMapTitle'])) $adminOptions['map_title'] = $_POST['GeoSmartMapTitle'];
		if(isset($_POST['GeoSmartMapZoom']) && !empty($_POST['GeoSmartMapZoom'])) 
		{
			if(is_numeric($_POST['GeoSmartMapZoom']))
			{
				$adminOptions['map_zoom'] = $_POST['GeoSmartMapZoom'];
			}
		}
		update_option('geosmart-options',$adminOptions);
		?>
		<div class="updated"><p><strong><?php _e('Settings Updated Successfully.','GeoSmart'); ?></strong></p></div>
		<?php
	}
		?>
<script type="text/javascript">
	var Key = '<?php echo $adminOptions['api-key']; ?>';
	function forceNumbers(evt)
	{
		var charCode = (evt.which) ? evt.which : event.keyCode;
		if(charCode>31 && (charCode<48 || charCode>57)) return false;
		return true;
	}
	function forceNumbers2(evt)
	{
		var charCode = (evt.which) ? evt.which : event.keyCode;
		if(charCode==45 || charCode==46) return true;
		if(charCode>31 && (charCode<48 || charCode>57)) return false;
		return true;
	}
	function toggleOptions()
	{
		if(document.getElementById('GeoSmartMap_yes').checked==true)
		{
			document.getElementById('map_options').style.display = "block";
		}
		if(document.getElementById('GeoSmartMap_yes').checked==false)
		{
			document.getElementById('map_options').style.display = "none";
		}
	}
	function reset()
	{
		document.getElementById('GeoSmartLatitude').value = 18.000000;
		document.getElementById('GeoSmartLongitude').value = -76.800003;
	}
	function fixKey()
	{
		document.getElementById('GeoSmartKey').disabled = "disabled";
		document.getElementById('KeyOk').style.display = "block";
		document.getElementById('change_key').style.display = "block";
	}
	function keyError()
	{
		document.getElementById('KeyError').style.display = "block";
	}
	function unFixKey()
	{	
		if(document.getElementById('GeoSmartChangeKey').checked==true)
		{
			document.getElementById('GeoSmartKey').disabled = "";
			document.getElementById('KeyOk').style.display = "none";
		}
		if(document.getElementById('GeoSmartChangeKey').checked==false)
		{
			document.getElementById('GeoSmartKey').value = Key;
			document.getElementById('GeoSmartKey').disabled = "disabled";
			document.getElementById('KeyOk').style.display = "block";
			
		}
		
	}
	
	var KillAlerts = true;
	var realAlert = alert;
    var alert = new Function('a', 'if(!KillAlerts){realAlert(a)}');
</script>

<script src="http://maps.google.com/maps?file=api&v=2&sensor=false&key=<?php echo $adminOptions['api-key']; ?>" type="text/javascript"></script>

<script type="text/javascript">
    KillAlerts = false;

    if (GBrowserIsCompatible()) 
	{
      	var ValidKey = true;
    } 
	else 
	{
      if (G_INCOMPAT) 
	  {
        alert("Your Google Maps API Key is Invalid!");
      } 
    } 
	document.getElementById('wrap_bar').style.display = "none";
</script>
<div class="wrap">
	<h2>GeoSmart Options</h2>
	<p>&diams;&nbsp;&nbsp;<strong>You are currently using GeoSmart version <?php echo GS_VERSION; ?>&nbsp;&nbsp;&diams;&nbsp;&nbsp;<a href="http://www.samuelfolkes.com/projects/geosmart" title="GeoSmart">Homepage</a> | <a href="<?php echo GS_PATH . 'readme.txt'; ?>" title="GeoSmart Readme">Readme</a> | <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=6436741">Donate</a> | <a href="http://twitter.com/SamuelFolkes" title="Twitter" target="_blank">Twitter</a></strong>&nbsp;&nbsp;&diams;</p>
	<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
		<input type="hidden" name="cmd" value="_s-xclick">
		<input type="hidden" name="hosted_button_id" value="6436009">
		<input type="image" src="https://www.paypal.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
		<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">
	</form>

		<?php
		$tableName = GS_TABLE;
		global $wpdb;
		$comments_list = $wpdb->get_results("SELECT comment_ID, comment_author_IP FROM $wpdb->comments WHERE comment_approved = '1' OR comment_approved = '0'", ARRAY_A);
		$geosmart_comments_list = $wpdb->get_results("SELECT comment_id FROM $tableName", ARRAY_A);
		$list = count($comments_list);
		
		foreach($comments_list as $comment)
		{
			$ip = $comment['comment_author_IP'];
			//echo $ip;
			if(strlen($ip)<2)
			{
				$list = $list - 1;
			}
		}
		if($list != count($geosmart_comments_list))
		{
		?>
	<form method="post" action="<?php echo $_SERVER['REQUEST_URI']; ?>" name="GeoSmart" id="GeoSmart">
	<?php wp_nonce_field('update-options'); ?>
		<div style="background:pink;border:1px solid black;padding:5px;text-align:center">
		<p><strong>Your GeoSmart database is not up to date! This means that location data for some comment authors will not be displayed. To correct this, Click synchronise below.</strong></p>
		<p><input type="submit" name="GeoSmartGetComments" value="<?php _e('Synchronize','GeoSmart'); ?>" /></p>
		</div>
		<?php
		}
		?>
		<hr style="background:#f9f9f9;color:#f9f9f9;border:1px dotted #464646;border-style:none none dotted" />
		<h3>Please enter your Google Maps API Key.</h3>
		<p>To display Google Maps you will need to obtain an API Key. Your Google Maps API Key allows your blog domain to use the Google Maps API. You can obtain a key free of cost <a href="http://code.google.com/apis/maps/signup.html" title="Google Maps API Key" target="_blank">here.</a></p>
		<table>
		<tr>
		<td style="height:40px">
		<input type="text" name="GeoSmartKey" id="GeoSmartKey" style="width:680px;height:40px;padding-top:10px" value="<?php _e(apply_filters('format_to_edit',$adminOptions['api-key']),'GeoSmart'); ?>" />
		</td>
		<td style="height:40px">
			<img src="<?php echo GS_PATH; ?>img/tick.png" style="height:100%;display:none" id="KeyOk" />
			<img src="<?php echo GS_PATH; ?>img/error.png" style="height:100%;display:none" id="KeyError" />
		</td>
		</tr>
		</table>
		<div>
		<p style="display:none" id="change_key">
			<label for="GeoSmartChangeKey"><input type="checkbox" name="GeoSmartChangeKey" id="GeoSmartChangeKey" value="1" onclick="unFixKey()" />&nbsp;Change API Key?</label>
		</p>
		</div>
		<script type="text/javascript">
		if(ValidKey) 
		{
			fixKey();
		}
		else
		{
			keyError();
		}
		</script>
		<hr style="background:#f9f9f9;color:#f9f9f9;border:1px dotted #464646;border-style:none none dotted" />
		<table style="width:100%">
			<tr>
				<td style="width:30%;text-align:right;vertical-align:top">Display Commenter Location:</td>
				<td style="width:70%;padding-left:15px">
					<p style="margin:0 0 0 0;font-size:11px">
						<label for="GeoSmartLocation_yes"><input type="radio" name="GeoSmartLocation" id="GeoSmartLocation_yes" value="1" <?php if($adminOptions['commenters'] == 1) _e('checked="checked"'); ?>  />&nbsp;Yes</label>
						<label for="GeoSmartLocation_no"><input type="radio" name="GeoSmartLocation" id="GeoSmartLocation_no" value="0" <?php if($adminOptions['commenters'] == 0) _e('checked="checked"'); ?>  />&nbsp;No</label>
					</p>
					<p style="font-size:11px">Selecting 'no' will disable the addition of comment author location data to comment metadata.</p>
				</td>
			</tr>
			<tr>
				<td style="width:30%;text-align:right;vertical-align:top">Display Comments Map:</td>
				<td style="width:70%;padding-left:15px">
					<p style="margin:0 0 0 0;font-size:11px">
						<label for="GeoSmartMap_yes"><input type="radio" onclick="toggleOptions()" name="GeoSmartMap" id="GeoSmartMap_yes" value="1" <?php if($adminOptions['map'] == 1) _e('checked="checked"'); ?>  />&nbsp;Yes</label>
						<label for="GeoSmartMap_no"><input type="radio" onclick="toggleOptions()" name="GeoSmartMap" id="GeoSmartMap_no" value="0" <?php if($adminOptions['map'] == 0) _e('checked="checked"'); ?>  />&nbsp;No</label>
					</p>
					<p style="font-size:11px">Selecting 'no' will disable the display of the comments map.</p>
				</td>
			</tr>
			<tr>
				<td style="width:30%;text-align:right;vertical-align:top">Display GeoSmart Link:</td>
				<td style="width:70%;padding-left:15px">
					<p style="margin:0 0 0 0;font-size:11px">
						<label for="GeoSmartLink_yes"><input type="radio" name="GeoSmartLink" id="GeoSmartLink_yes" value="1" <?php if($adminOptions['show_link'] == 1) _e('checked="checked"'); ?>  />&nbsp;Yes</label>
						<label for="GeoSmartLink_no"><input type="radio" name="GeoSmartLink" id="GeoSmartLink_no" value="0" <?php if($adminOptions['show_link'] == 0) _e('checked="checked"'); ?>  />&nbsp;No</label>
					</p>
					<p style="font-size:11px">Selecting 'no' will disable the display of the comments map.</p>
				</td>
			</tr>
			<tr>
				<td style="width:30%;text-align:right;vertical-align:top">Map Title:</td>
				<td style="width:70%;padding-left:15px">
					<p style="margin:0 0 0 0"><input type="text" name="GeoSmartMapTitle" id="GeoSmartMapTitle" style="width:300px" value="<?php _e(apply_filters('format_to_edit',$adminOptions['map_title']),'GeoSmart'); ?>" /></p>
					<p style="font-size:11px">The title to be displayed above the map.</p>
				</td>
			</tr>
			<tr>
				<td style="width:30%;text-align:right;vertical-align:top">Map Dimensions:</td>
				<td style="width:70%;padding-left:15px">
					<table>
						<tr>
							<td style="width:80px"><p style="margin:0 0 0 0;font-size:11px">Width</p></td>
							<td style="width:80px"><p style="margin:0 0 0 0;font-size:11px">Height</p></td>
						</tr>
						<tr>
							<td><label for="GeoSmartWidth"><input type="text" style="width:40px" maxlength="4" onkeypress="return forceNumbers(event)" name="GeoSmartWidth" id="GeoSmartWidth" value="<?php _e(apply_filters('format_to_edit',$adminOptions['map_width']),'GeoSmart'); ?>"  />px</label></td>
							<td><label for="GeoSmartHeight"><input type="text" style="width:40px" maxlength="4" onkeypress="return forceNumbers(event)" name="GeoSmartHeight" id="GeoSmartHeight" value="<?php _e(apply_filters('format_to_edit',$adminOptions['map_height']),'GeoSmart'); ?>"  />px</label></td>
						</tr>
					</table>	
					<p style="font-size:11px">The height and width of the map in pixels.</p>
				</td>
			</tr>
			<tr>
				<td style="width:30%;text-align:right;vertical-align:top">Map Placement Control:</td>
				<td style="width:70%;padding-left:15px">
					<p style="margin:0 0 0 0;font-size:11px">
						<label for="GeoSmartAuto_yes"><input type="radio" name="GeoSmartAuto" id="GeoSmartAuto_yes" value="1" <?php if($adminOptions['auto_position'] == 1) _e('checked="checked"'); ?>  />&nbsp;Auto</label>
						<label for="GeoSmartAuto_no"><input type="radio" name="GeoSmartAuto" id="GeoSmartAuto_no" value="0" <?php if($adminOptions['auto_position'] == 0) _e('checked="checked"'); ?>  />&nbsp;Manual</label>
					</p>
					<p style="font-size:11px">If set to auto, GeoSmart will automatically find an area in your theme to place the map. If set to manual, you will need to insert <strong>`&lt;?php geosmart_map(); &gt;`</strong> in your comments template (usually comments.php) wherever you want a comment map displayed. </p>
				</td>
			</tr>
			<tr>
				<td style="width:30%;text-align:right;vertical-align:top">Map Default Zoom Level:</td>
				<td style="width:70%;padding-left:15px">
					<p style="margin:0 0 0 0"><input type="text" name="GeoSmartMapZoom" id="GeoSmartMapZoom" maxlength="2" onkeypress="return forceNumbers(event)" style="width:30px" value="<?php _e(apply_filters('format_to_edit',$adminOptions['map_zoom']),'GeoSmart'); ?>" /></p>
					<p style="font-size:11px">The default zoom level of the map when it loads. The higher the number the greater the zoom.</p>
				</td>
			</tr>
			<tr>
				<td style="width:30%;text-align:right;vertical-align:top">Map Center:</td>
				<td style="width:70%;padding-left:15px">
					<table style="margin-top:0px">
						<tr>
							<td ><p style="margin:0 0 0 0;font-size:11px">Latitude</p></td>
							<td><p style="margin:0 0 0 0;font-size:11px">Longitude</p></td>
							<td>&nbsp;</td>
						</tr>
						<tr>
							<td><label for="GeoSmartLatitude"><input type="text" maxlength="12" style="width:100px" onkeypress="return forceNumbers2(event)" name="GeoSmartLatitude" id="GeoSmartLatitude" value="<?php _e(apply_filters('format_to_edit',$adminOptions['map_lat']),'GeoSmart'); ?>"  /></label></td>
							<td><label for="GeoSmartLongitude"><input type="text" maxlength="12" style="width:100px" onkeypress="return forceNumbers2(event)" name="GeoSmartLongitude" id="GeoSmartLongitude" value="<?php _e(apply_filters('format_to_edit',$adminOptions['map_long']),'GeoSmart'); ?>" /></label></td>
							<td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" name="resetCenter" onclick="reset()" value="<?php _e('Reset Values','GeoSmart'); ?>" /></td>
						</tr>
					</table>
					<p style="font-size:11px">The coordinates of the point which serves as the center of the map.</p>
				</td>
			</tr>
		</table>
	
		<p class="submit">
			<input type="submit" name="GeoSmartUpdate" value="<?php _e('Update Settings &raquo;','GeoSmart'); ?>" />
			<input type="button" onclick="resetAll()" name="GeoSmartResetAll" value="<?php _e('Reset Defaults &raquo;','GeoSmart'); ?>" />
		</p>
	</form>
</div>
<?php
}

/**
 * Inserts page header information.
 */
 public function headerCode()
 {
	global $post;
	$options = get_option('geosmart-options');
	$apiKey = $options['api-key'];
	$map_lat = $options['map_lat'];
	$map_long = $options['map_long'];
	$map_zoom = $options['map_zoom'];
	?>
	<!--Start GeoSmart by Samuel Folkes-->
	<link rel="stylesheet" type="text/css" href="<?php echo GS_PATH . '/css/geosmart.css'; ?>" />
	<script src="http://maps.google.com/maps?file=api&v=2&sensor=false&key=<?php echo $apiKey?>" type="text/javascript"></script>
	<script type="text/javascript">
	function initialize() 
	{
		if (GBrowserIsCompatible()) 
		{
			map = new GMap2(document.getElementById("gs_map_canvas"));    
			map.setCenter(new GLatLng(<?php echo $map_lat; ?>, <?php echo $map_long; ?>), <?php echo $map_zoom; ?>);    
			map.setUIToDefault();

			jQuery.getJSON('<?php echo WP_PLUGIN_URL?>/geosmart/getcoordinates.php?post=<?php echo $post->ID?>&path=<?php echo ABSPATH?>',
			function(data) {
			for(var x=0; x < data.length; x++) {
            point = new GLatLng(data[x].latitude, data[x].longitude);
            marker = new GMarker(point);
            map.addOverlay(marker);
			}
			}
			);       
		}
	}
	window.onload = initialize;
	<!--End GeoSmart by Samuel Folkes-->
	</script>
	<?php
}

/**
 * Creates database table required by plugin.
 */
 private function tableCreate()
 {
	global $wpdb;
	$tableName = $wpdb->prefix . 'geosmart';
	if($wpdb->get_var("SHOW TABLES LIKE '$tableName'") != $tableName) 
	{
		$sql = "CREATE TABLE $tableName (
			id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
			ip VARCHAR (15) NOT NULL,
			latitude FLOAT(10,6) NOT NULL,
			longitude FLOAT(10,6) NOT NULL,
			country VARCHAR (50) NOT NULL,
			region VARCHAR (50) NOT NULL,
			comment_id INTEGER NOT NULL UNIQUE KEY,
			post_id INTEGER NOT NULL 
		);";
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
	}
 }

/**
 *Sets plugin options.
 */
 public function setOptions()
 {
	$geosmart_options['api-key'] = '';
	$geosmart_options['commenters'] = 1;
	$geosmart_options['map'] = 1;
	$geosmart_options['show_link'] = 1;
	$geosmart_options['auto_postion'] = 1;
	$geosmart_options['map_width'] = 500;
	$geosmart_options['map_height'] = 300;
	$geosmart_options['map_long'] = -76.800003;
	$geosmart_options['map_lat'] = 18.000000;
	$geosmart_options['map_zoom'] = 2;
	$geosmart_options['map_title'] = 'Comments Map';
	$opts = get_option('geosmart-options');
	if(empty($opts))
	update_option('geosmart-options', $geosmart_options);
 }

/**
 * Runs on plugin activation to execute setup functions.
 */
 public function pluginInit()
 {
	$this->tableCreate();
	$this->setOptions();
 }

/**
 * Scans WP database to retrieve comment author IP's and updates GeoSmart database with location information.
 */
 private function getCommentorLocations()
 {
	$ipString = "";
	global $wpdb;
	$comments = $wpdb->get_results("SELECT comment_ID, comment_post_ID, comment_author_IP FROM $wpdb->comments WHERE comment_approved = '1' OR comment_approved = '0'", ARRAY_A);
	$totalComments = count($comments);
	if($totalComments < 25)
		{
			foreach($comments as $comment)
			{
				$ipString .= $comment['comment_author_IP'] . ',';
				$idArray[] = $comment['comment_ID'];
				$postArray[] = $comment['comment_post_ID'];
			}
			$ipString = trim($ipString);
			$ipString = rtrim($ipString,',');
			$dataArray = $this->apiRequest($ipString,1);
			
			for($i=0;$i<$totalComments;$i++)
			{
				$ip = $dataArray['Locations'][$i]['Ip'];
				$status = $dataArray['Locations'][$i]['Status'];
				$lat = $dataArray['Locations'][$i]['Latitude'];
				$long = $dataArray['Locations'][$i]['Longitude'];
				$country = $dataArray['Locations'][$i]['CountryName'];
				$region = $dataArray['Locations'][$i]['RegionName'];
				if($status=="OK")
				$wpdb->insert(GS_TABLE, array('ip' => $ip, 'latitude' => $lat, 'longitude' => $long, 'country' => $country, 'region' => $region, 'comment_id' => $idArray[$i], 'post_id' => $postArray[$i]), array('%s', '%f', '%f', '%s', '%s'));
			}
		}
	else
	{
		$i = 0;
		$n = 0;
		$width = 0;
		$percentage = 0;
		$widthPerIteration = 500/$totalComments;
		ob_start();
		echo '<div id="wrap_bar">';
		foreach($comments as $comment)
		{
			$ipString .= $comment['comment_author_IP'] . ',';
			$idArray[] = $comment['comment_ID'];
			$postArray[] = $comment['comment_post_ID'];
			echo '<div id="_bar_progress_" class="progress_wrapper" style="width:500px;position:absolute;top:200px;left:50%;margin-left:-150px;background:#f9f9f9;"><small>Completed:' . round(($width/500)*100) . '%</small><div style="border:1px solid #ccc;width:100%;"><div class="progress" style="width:' . $width . 'px;height:15px;background-color:#000;"></div></div></div>';
			ob_flush();
			flush();
			$width = $width + $widthPerIteration;
			
			$i++;
			if($i % 24 == 0)
			{
				$ipString = trim($ipString);
				$ipString = rtrim($ipString,',');
				$dataArray = $this->apiRequest($ipString,1);
				$ipString = "";
				
				if($n<$totalComments)
				{
					$c = $totalComments - $n;
				}
				else
				{
					$c = $n+25;
				}
				for($t=$n;$t<$c;$t++)
				{
					$ip = $dataArray['Locations'][$t]['Ip'];
					$status = $dataArray['Locations'][$t]['Status'];
					$lat = $dataArray['Locations'][$t]['Latitude'];
					$long = $dataArray['Locations'][$t]['Longitude'];
					$country = $dataArray['Locations'][$t]['CountryName'];
					$region = $dataArray['Locations'][$t]['RegionName'];
					$n = $n+25;
					if(isset($idArray[$t]) && $status=="OK")
					$wpdb->insert(GS_TABLE, array('ip' => $ip, 'latitude' => $lat, 'longitude' => $long, 'country' => $country, 'region' => $region, 'comment_id' => $idArray[$t], 'post_id' => $postArray[$t]), array('%s', '%f', '%f', '%s', '%s'));
				}
				$m = $i;
			
				sleep(2);
			}
				if($i==$totalComments)
				{
					$ipString = trim($ipString);
					$ipString = rtrim($ipString,',');
					$dataArray2 = $this->apiRequest($ipString,1);
					$rem = $totalComments - $m;
					for($c=0;$c<$rem;$c++)
					{
						$ip = $dataArray2['Locations'][$c]['Ip'];
						$status = $dataArray2['Locations'][$c]['Status'];
						$lat = $dataArray2['Locations'][$c]['Latitude'];
						$long = $dataArray2['Locations'][$c]['Longitude'];
						$country = $dataArray2['Locations'][$c]['CountryName'];
						$region = $dataArray2['Locations'][$c]['RegionName'];
						if(isset($idArray[$m]) && $status=="OK")
						$wpdb->insert(GS_TABLE, array('ip' => $ip, 'latitude' => $lat, 'longitude' => $long, 'country' => $country, 'region' => $region, 'comment_id' => $idArray[$m], 'post_id' => $postArray[$m]), array('%s', '%f', '%f', '%s', '%s'));
						$m++;
					}
					echo '<div id="progbar_" class="progress_wrapper" style="width:500px;position:absolute;top:200px;left:50%;margin-left:-150px;background:#f9f9f9;"><small>Completed:' . round(($width/500)*100) . '%</small><div style="border:1px solid #ccc;width:100%;"><div class="progress" style="width:500px;height:15px;background-color:#000;"></div></div></div>';
					ob_flush();
					flush();
				}
			
		}
		echo '</div>';
		ob_flush();
		flush();
	}
 }

/**
 * Communicates with external API.
 *
 * @params string - $ipString IP addresses, integer - $mode Determines which API url is used.
 * @return array - IP lookup results.
 */
 private function apiRequest($ipString,$mode)
 {
	if($mode==1) $url = "http://ipinfodb.com/ip_query2.php?ip=$ipString&output=json";
	if($mode==2) $url = "http://ipinfodb.com/ip_query.php?ip=$ipString&output=json";

	$options = array(
	CURLOPT_RETURNTRANSFER => true,
	CURLOPT_HEADER => false,
	CURLOPT_FOLLOWLOCATION => true,
	CURLOPT_ENCODING => "",
	CURLOPT_USERAGENT => "Mozilla/4.0 (compatible; MSIE 6.0; WindowsNT 5.1)",
	CURLOPT_AUTOREFERER => true,
	CURLOPT_TIMEOUT => 120,
	CURLOPT_CONNECTTIMEOUT => 120,
	CURLOPT_MAXREDIRS => 10,
	);

	$ch = curl_init($url);
	curl_setopt_array($ch, $options);
	$content = curl_exec($ch);
	$err = curl_errno($ch);
	$errmsg = curl_error($ch);
	$header = curl_getinfo($ch);
	curl_close($ch);
	$header['content'] = $content;
	return $this->parseJsonData($content);
 }

/**
 * Parses JSON encoded strings.
 *
 * @param string - $json JSON encoded string.
 * @return array - Decoded JSON string in the form of an array.
 */
 private function parseJsonData($json)
 {
	$dataArray = json_decode($json,true);
	return $dataArray;
 }

/**
 * Triggered by comments_post action hook, looks up comment author IP and adds info to GeoSmart database.
 *
 * @param integer $comment_id - Comment ID
 */
 public function newComment($comment_id)
 {
	$comment = get_comment($comment_id);
	$status = $comment->comment_approved;
	if($status == 'spam') return;
	$id = $comment->comment_ID;
	$ip = $comment->comment_author_IP;
	$post_id = $comment->comment_post_ID;
	$dataArray = $this->apiRequest($ip,2);
	$status = $dataArray['Status'];
	$lat = $dataArray['Latitude'];
	$long = $dataArray['Longitude'];
	$country = $dataArray['CountryName'];
	$region = $dataArray['RegionName'];
	global $wpdb;
	$wpdb->insert(GS_TABLE, array('ip' => $ip, 'latitude' => $lat, 'longitude' => $long, 'country' => $country, 'region' => $region, 'comment_id' => $id, 'post_id' => $post_id), array('%s', '%f', '%f', '%s', '%s'));
	return;
 }

 /**
  * Modifies comment metadata to display comment author location.
  *
  * @param string - $author Comment author name.
  * @return string - Modified comment metadata
  */
 public function addLocation($author = '')
 {
	$options = get_option('geosmart-options');
	if($options['commenters']==0) return $author;
	$id = get_comment_ID();
	global $wpdb;
	$tableName = GS_TABLE;
	$wpdb->show_errors();
	$row = $wpdb->get_row("SELECT country, region FROM $tableName WHERE comment_id = $id", ARRAY_A);
	$region = $row['region'];
	$country = $row['country'];
	if($region==null && $country==null)
	{
		$location = "";
	}
	if($region!=null && $country!=null)
	{
		$location = " <small id=\"gs_author_location\">from $region, $country</small>";
	}
	if($region==null && $country!=null)
	{
		$location = " <small id=\"gs_author_location\">from $country</small>";
	}
	return $author .= $location;
 }
 
/** 
 * Adds GeoSmart settings link to plugin page.
 *
 * @params string - $file Plugin file path, array - $links Links associated with plugin
 * @return array - Links associated with plugin.
 */
 public function addSettingsLink( $links, $file )
 {
	if ( empty($this->_pluginBasename) ) 
	{
		$this->_pluginBasename = plugin_basename(__FILE__);
	}
	if ( $file == $this->_pluginBasename ) 
	{
		$link = '<a href="options-general.php?page=GeoSmart">' . __('Settings', 'GeoSmart') . '</a>';
		array_unshift( $links, $link );
	}
	return $links;
 }
 
/**
 * Loads scripts required by plugin (jOuery).
 */ 
 public function loadScripts()
 {
	wp_enqueue_script(jquery);
 }
 
/**
 * Adds Google Map <div> to comments template.
 * @return - Modified comments template.
 */
 public function addMap($comments_filepath)
 {
	$options = get_option('geosmart-options');
	if($options['map']==0) return $comments_filepath;
	$width = $options['map_width'];
	$height = $options['map_height'];
	$title = $options['map_title'];
	$show_link = $options['show_link'];
	$content = '<h3 id="gs_map_title">' . $title . '</h3><div id="gs_map_canvas" style="width:' . $width . 'px; height:' . $height . 'px"></div>';
	if($show_link==1) $content .= '<small id="gs_credits">Location data courtesy of <a href="http://www.samuelfolkes.com/projects/geosmart/" title="GeoSmart" target"_blank">GeoSmart</a></small>';
	if(have_comments()) 
	{
		echo $content;
		if(eregi("MSIE",$_SERVER['HTTP_USER_AGENT']))
		{
			?>
			<script type="text/javascript"> 
			function WindowOnload(f) 
			{ 
				var prev=window.onload; 
				window.onload=function()
				{ 
					if(prev)prev(); f(); 
				} 
			} 
			WindowOnload(initialize); 
			</script> 
			<?php
		}
	}
	return $comments_filepath;
 }
}

$geoSmart = new geoSmart;

/**
 * Register GeoSmart options page.
 */
 if (!function_exists("GeoSmart_ap")) 
 {
	function GeoSmart_ap() 
	{
		global $geoSmart;
		if (!isset($geoSmart)) 
		{
			return;
		}
		if (function_exists('add_options_page')) 
		{
			add_options_page('GeoSmart','GeoSmart',9,'GeoSmart',array(&$geoSmart, 'displayAdmin'));
		}
	}
 }
 
/**
 * Displays comments map when 'Map Placement' is set to manual.
 */ 
 function geosmart_map()
 {
	$options = get_option('geosmart-options');
	if($options['map']==0) return;
	if($options['auto_position']==0) return;
	$width = $options['map_width'];
	$height = $options['map_height'];
	$title = $options['map_title'];
	$content = '<h3 id="gs_map_title">' . $title . '</h3><div id="gs_map_canvas" style="width:' . $width . 'px; height:' . $height . 'px"></div>';
	if($show_link==1) $content .= '<small id="gs_credits">Location data courtesy of <a href="http://www.samuelfolkes.com/projects/geosmart/" title="GeoSmart" target"_blank">GeoSmart</a></small>';
	if(have_comments()) 
	{
		echo $content;
		if(eregi("MSIE",$_SERVER['HTTP_USER_AGENT']))
		{
			?>
			<script type="text/javascript"> 
			function WindowOnload(f) 
			{ 
				var prev=window.onload; 
				window.onload=function()
				{ 
					if(prev)prev(); f(); 
				} 
			} 
			WindowOnload(initialize); 
			</script> 
			<?php
		}
	}
 }

/**
 * Filters and Actions
 */
 add_action('admin_menu', 'GeoSmart_ap');
 add_action('wp_head', array(&$geoSmart, 'headerCode'), 1);
 add_action('activate_geosmart/geosmart.php', array(&$geoSmart, 'pluginInit'));
 add_action('comment_post', array(&$geoSmart, 'newComment'));
 add_filter('get_comment_author', array(&$geoSmart, 'addLocation'));
 add_filter( 'plugin_action_links', array(&$geoSmart, 'addSettingsLink'), 10, 2 );
 add_action('init', array(&$geoSmart, 'loadScripts'));
 $options = get_option('geosmart-options');
 if($options['auto_position']==1)
 add_filter('comments_template', array(&$geoSmart, 'addMap'));

?>